//   Copyright 2012 Georg-August-Universität Göttingen, Germany
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.

package de.ugoe.cs.autoquest.tasktrees.treeifc;

/**
 * <p>
 * TODO comment
 * </p>
 * 
 * @author Patrick Harms
 */
public class TaskTreeUtils {
    
    /**
     *
     */
    public static boolean isChild(ITask potentialChild, ITask potentialParent) {
        if (potentialParent instanceof IStructuringTemporalRelationship) {
            for (ITask child : ((IStructuringTemporalRelationship) potentialParent).getChildren()) {
                if (child.equals(potentialChild) || isChild(potentialChild, child)) {
                    return true;
                }
            }
        }
        else if (potentialParent instanceof IMarkingTemporalRelationship) {
            ITask child = ((IMarkingTemporalRelationship) potentialParent).getMarkedTask();
            if (child.equals(potentialChild) || isChild(potentialChild, child)) {
                return true;
            }
        }
        
        return false;
    }

    
    /**
     *
     */
    private TaskTreeUtils() { /* prevent instantiation */ }
}
